import sys

from PyQt4 import QtCore, QtGui, QtWebKit


HTML = """
<html>
   <head>
      <title>QtWebKit Plug-in Test</title>
   </head>
   <body>
      <object type="application/x-qt-plugin" classid="MyCalendarWidget" name="calendar" height=300 width=500></object>
      <script>
         calendar.setGridVisible(true);
         calendar.setCurrentPage(1985, 5);
      </script>
   </body>
</html>
"""


class MyWebView(QtWebKit.QWebView):

    def __init__(self, parent=None):

        super(MyWebView, self).__init__(parent)

        self._page = MyWebPage(self)
        self.setPage(self._page)


class MyWebPage(QtWebKit.QWebPage):

    def __init__(self, parent=None):

        super(MyWebPage, self).__init__(parent)

        self.settings().setAttribute(QtWebKit.QWebSettings.PluginsEnabled, True)

    def createPlugin(self, classid, url, paramNames, paramValues):

        return MyCalendarWidget(self.view())


class MyCalendarWidget(QtGui.QCalendarWidget):

    def __init__(self, parent=None):

        super(MyCalendarWidget, self).__init__(parent)

        # Just to prove that this is being used.
        self.setFirstDayOfWeek(QtCore.Qt.Monday)


app = QtGui.QApplication(sys.argv)

viewer = MyWebView()
viewer.setHtml(HTML)
viewer.show()

app.exec_()